# Sane: Forus Labs' Core Dart Library
[![Travis CI](https://img.shields.io/travis/forus-labs/sane/master?logo=travis)](https://travis-ci.com/forus-labs/sane)
[![Codecov](https://codecov.io/gh/forus-labs/sane/branch/master/graph/badge.svg)](https://codecov.io/gh/forus-labs/sane)
[![Pub Dev](https://img.shields.io/pub/v/sane)](https://pub.dev/packages/sane)

Sane is Forus Labs' core library that includes annotations, collection types, date-times and utilities for numerics and strings.

**This is a bleeding edge version of Sane. For a production ready and documented version, please refer to the [stable branch](https://github.com/forus-labs/sane/tree/stable).**


### [`sane.collection`](https://pub.dev/documentation/sane/latest/sane.collection/sane.collection-library.html)

* Delegating collection types
* Observable collection types
* Tuples (`Pair`, `Triple` and `Quad`)
* Pseudo-weak collection types

### [`sane.core`](https://pub.dev/documentation/sane/latest/sane.core/sane.core-library.html)

* Annotations (i.e. `nullable`, `tainted`)
* Pseudo-weak reference
* Utilities for numerics and strings

### [`sane.time`](https://pub.dev/documentation/sane/latest/sane.time/sane.time-library.html)

* Distinct global and localized date-time types
* `Period` type
* `Span` type
* `Time` type
* Utilities for rounding date-times

