/// ASCII value for whitespace (` `).
const int whitespace = 32;


/// Utilities for formatting `String`s.
extension Strings on String {

  /// Capitalizes the first letter of `this`.
  String capitalize() {
    if (isBlank) {
      return this;

    } else if (length == 1){
      return toUpperCase();

    } else {
      return this[0].toUpperCase() + substring(1);
    }
  }


  /// Returns `true` if `this` is empty or contains only spaces.
  bool get isBlank => isEmpty || codeUnits.every((unit) => unit == whitespace);

  /// Returns `true` if `this` is not empty and does not contains only spaces.
  bool get isNotBlank => !isBlank;

}