import 'package:mockito/mockito.dart';
import 'package:test/test.dart';

import 'package:sane/collection.dart';


class MockList extends Mock implements List<dynamic> {}


void main() {

  final list = MockList();
  final delegate = DelegateList(list);

  group('DelegateListMixin', () {

    test('[i]', () {
      when(list[0]).thenReturn(1);

      expect(delegate[0], 1);
      verify(list[0]);
    });

    test('[i] = E', () {
      delegate[0] = 'A';
      verify(list[0] = 'A');
    });

    group('length', () {

      test('get', () {
        when(list.length).thenReturn(9001);

        expect(delegate.length, 9001);
        verify(list.length);
      });

      test('set', () {
        delegate.length = 69;

        verify(list.length = 69);
      });

    });

    test('delegate', () => expect(delegate.delegate, same(list)));

  });

}