import 'package:mockito/mockito.dart';
import 'package:test/test.dart';

import 'package:sane/collection.dart';


class MockMap extends Mock implements DelegateMap<dynamic, dynamic> {}


void main() {

  final map = MockMap();
  final delegate = DelegateMap(map);

  group('DelegateListMixin', () {

    test('[K]', () {
      when(map[0]).thenReturn(1);

      expect(delegate[0], 1);
      verify(map[0]);
    });

    test('[K] = V', () {
      delegate[0] = 'A';
      verify(map[0] = 'A');
    });

    test('clear', () {
      delegate.clear();

      verify(map.clear());
    });

    test('keys', () {
      final list = [];
      when(map.keys).thenReturn(list);

      expect(delegate.keys, same(list));
      verify(map.keys);
    });

    test('remove', () {
      delegate.remove('A');

      verify(map.remove('A'));
    });

    test('delegate', () => expect(delegate.delegate, same(map)));

  });

}