import 'package:mockito/mockito.dart';
import 'package:test/test.dart';

import 'package:sane/collection.dart';


class MockSet extends Mock implements Set<dynamic> {}


void main() {

  final set = MockSet();
  final delegate = DelegateSet(set);

  group('DelegateSetMixin', () {

    test('add', () {
      delegate.add('a');
      
      verify(set.add('a'));
    });

    test('contains', () {
      delegate.contains('a');

      verify(set.contains('a'));
    });

    test('lookup', () {
      delegate.lookup('a');

      verify(set.lookup('a'));
    });

    test('remove', () {
      delegate.remove('a');

      verify(set.remove('a'));
    });

    test('iterator', () {
      delegate.iterator;

      verify(set.iterator);
    });

    test('length', () {
      delegate.length;

      verify(set.length);
    });

    test('delegate', () => expect(delegate.delegate, same(set)));

    test('toSet', () {
      final other = <dynamic>{};
      when(set.toSet()).thenReturn(other);

      final cloned = delegate.toSet();

      expect(cloned, isNot(same(delegate)));
      expect(cloned.delegate, same(other));
      verify(set.toSet());
    });
    
  });


}