import 'package:test/test.dart';

import 'package:sane/collection.dart';


void main() {

  group('modification', () {

    test('clear', () {
      const modification = Modification.clear();

      expect(modification.kind, Kind.clear);
      expect(modification.key, null);
      expect(modification.value, null);
    });

    test('add', () {
      const modification = Modification.add(1, 'a');

      expect(modification.kind, Kind.add);
      expect(modification.key, 1);
      expect(modification.value, 'a');
    });

    test('remove', () {
      const modification = Modification.remove(1, 'a');

      expect(modification.kind, Kind.remove);
      expect(modification.key, 1);
      expect(modification.value, 'a');
    });

    test('clear', () {
      const modification = Modification.clear();

      expect(modification.kind, Kind.clear);
      expect(modification.key, isNull);
      expect(modification.value, isNull);
    });

  });

}
