import 'package:test/test.dart';

import 'package:sane/core.dart';


class StubSetHandle extends SetHandle<int> {

  StubSetHandle(Set<int> set) : super(set);

}

class StubMapHandle extends MapHandle<String, int> {

  StubMapHandle(Map<String, int> map) : super(map);

}


void main() {

  group('ConstantHandle', () {

    const handle = ConstantHandle(value: true);

    test('value', () => expect(const ConstantHandle(value: false).value, false));

    test('contains', () => expect(handle.contains(1), true));

    test('modifications', () => expect(handle.modifications, 0));

    group('mods', () {

      test('get', () => expect(handle.mods, 0));

      test('set', () => expect((handle..mods = 0).mods, 0));

    });

  });

  group('SetHandle', () {

    final handle = StubSetHandle({1});

    test('contains', () => expect(handle.contains(1), true));

    test('does not contain', () => expect(handle.contains(2), false));

  });

  group('MapHandle', () {

    final handle = StubMapHandle({'a': 1});

    test('contains', () => expect(handle.contains('a'), true));

    test('does not contain', () => expect(handle.contains('b'), false));

  });

}