import 'package:test/test.dart';

import 'package:sane/time.dart';


void main() {

  group('pack', () {

    for (final day in [0, 8]) {
      test('assertion for invalid day: $day', () => expect(
        () => pack([1, 2, day]),
        throwsA(predicate<AssertionError>((e) => e.message == 'Invalid weekday in: [1, 2, $day], weekday must be between 1 and 7'))
      ));
    }

    test('packs', () => expect(pack([1, 2, 3, 4, 5, 6, 7]), 127));

  });

  group('unpack', () {

    for (final value in [-1, 128]) {
      test('assertion for invalid value: $value', () => expect(
          () => unpack(value),
          throwsA(predicate<AssertionError>((e) => e.message == 'Invalid value: $value, value must be between 0 and 127'))
      ));
    }

    test('unpacks', () => expect(unpack(127), {1, 2, 3, 4, 5, 6, 7}));

  });

}